<?php
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
abstract class action_in_margin {
	public $name;
	abstract public function action_html();
}
class ajax_action_in_margin extends action_in_margin {
	public $object;
	public $param;
	public $display;
	public function ajax_action_in_margin( $name, $obj, $param = null, $display = null ) {
		$this->name = $name;
		$this->object = $obj;
		$this->param = $param;
		$this->display = $display;
	}
	public function action_html() {
    	?><a href="<?= $this->object->context->getActionLink($this->name, $this->object, $this->param) ?>">[<?= $this->display == null ? $this->name : $this->display ?>]</a><?php
	}
	
}
class onclick_action_in_margin extends action_in_margin {
	public $onclick;
	public $comment;
	public function onclick_action_in_margin( $name, $comment, $onclick ) {
		$this->name = $name;
		$this->comment = $comment;
		$this->onclick = $onclick;
	}
	public function action_html() {
		?><a <?= $this->hrefcode() ?>>[<?= $this->name ?>]</a><?php
	}
	public function hrefcode() {
		return "href=\"javascript://" . $this->comment . "\" onclick=\"" . $this->onclick . ";return false;\"";
	}
}
class href_action_in_margin extends action_in_margin {
	public $name;
	public $url;
	public function href_action_in_margin( $name, $url ) {
		$this->name = $name;
		$this->url = $url;
	}
	public function action_html() {
    	?><a target="_new" href="<?= $this->url ?>"><?= $this->name ?></a><?php
	}
}
?>
