<?php
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "ifactory.class.php" );
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "functions.php" );

class AllFactories implements IFactory {
  public function getObjectsForContext( $context ) {
    return $this->getObjects( $context, "getObjectsForContext" );
  }
  public function getActiveObjects( $context ) {
    return $this->getObjects( $context, "getActiveObjects" );
  }

  function getObjects( $context, $function ) {
    $dir = $context->get("components_directory");
    $instances = array( );
    foreach( dirs($dir) as $component ) {
      if( file_exists( $dir . "$component/factory.php" ) ) {
	include_once( $dir . "$component/factory.php" );
	$factoryname = $component . "_Factory";
	$obj = new $factoryname ;
	$insts = $obj->$function( $context );
	foreach( $insts as $each ) {
		$each->test_label = $component . '/' . get_class( $each );
	}
	$instances = array_merge( $instances, $insts );
      }
    }
    usort($instances, 'component_order_sort');
    return $instances;
  }

  public function getObjectForId( $classname, $id, $context ) {
    return array();
  }

}
function component_order_sort($a, $b) {
	if($a->sort_order() == $b->sort_order()) {
		return strcmp($a->title(), $b->title());
	} else {
		return $a->sort_order() - $b->sort_order();
	}
}

?>
