<LINK rel="stylesheet"
      type="text/css"
      href="test.css"/>
<?php
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "allfactories.class.php" );
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "immediatecron.class.php" );
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "dailycron.class.php" );

function userErrorHandler($errno, $errmsg, $filename, $linenum, $vars) {
  $errortype = array (
    E_ERROR => 'Error',
    E_WARNING => 'Warning',
    E_PARSE => 'Parsing Error',
    E_NOTICE => 'Notice',
    E_CORE_ERROR => 'Core Error',
    E_CORE_WARNING => 'Core Warning',
    E_COMPILE_ERROR => 'Compile Error',
    E_COMPILE_WARNING => 'Compile Warning',
    E_USER_ERROR => 'User Error',
    E_USER_WARNING => 'User Warning',
    E_USER_NOTICE => 'User Notice',
    E_STRICT => 'Runtime Notice',
    E_RECOVERABLE_ERROR => 'Catchable Fatal Error');
  trouble ("PHP $errortype[$errno]:<br>$errmsg<br>$filename ($linenum)");
}

//error_reporting( 0 ); // commented out because it was blocking the reporting of fatal errors
$old_error_handler = set_error_handler("userErrorHandler");

// Store component usage for later filtering of email
$ignore_email_components = array();

ob_start();
require_once( $GLOBALS['CLASSES_DIRECTORY'] . "/initialize-demo-database.class.php" );
$initializer = new InitializeDemoDatabase();
$initializer->initialize( $context );
$html = ob_get_clean();
if( strpos( $html, 'Trouble' )) {
	echo $html;
	trouble( "Database checking and creation errors");
}


/*
 * =============== Test Fixture functions =============
 */

$portal_objects = array();
$current = false; //the current object or subobject, false if none

function login( $user ) {
  global $context;
  global $portal_objects;
  global $effective_user;

  // the user
  $context->set("USER", $user );
  $effective_user = $user;
  $context->store_user_email();

  // build the portal page for the user
  $allfactory = new AllFactories();
  $portal_objects = $allfactory->getObjectsForContext( $context );
}

function component( $component, $classname, $id=false ) {
  global $current;
  global $context;
  global $portal_objects;

  require_once( $GLOBALS['CLASSES_DIRECTORY'] . "ifactory.class.php");
  require_once($GLOBALS['COMPONENTS_DIRECTORY'] . "$component/factory.php");
  $factoryclass = $component . "_Factory";
  $factory = new $factoryclass();
  $current = $factory->getObjectForId( $classname, $id, $context );
  $portal_objects = array($current);
  if (is_null($current)) {
  	trouble("factory can't make $classname");
  }

  $portal_objects = array($current);
  echo $current->outer_html();
  $current->test_label = "$component/$classname";
  report_test_label($current);
  $_POST = array();
  $_REQUEST = array();
}

function note( $string, $user=false) {
	global $effective_user, $effective_label;
	$effective_label = "note";
	if ($user) $effective_user = $user;
        echo "<p><table cellpadding=10 width=400 bgcolor=#bbbbdd><tr><td><font size=+2>Note: </font>";
        echo $string;
        echo "</table>";
}
function variation( $string ) {
	global $context;
	$articles = array('where', 'is', 'for', 'with', 'such_that', 'when', 'whence');
	$prefix = $_GET['file'];
	$prefix = substr($prefix, 0, count($prefix)-5); // remove '.txt'
	$suffix = str_replace( ' ', '_', $string );
	$suffix .= '.txt';
	foreach( $articles as $article ) {
		if( file_exists( "scripts/${prefix}_${article}_${suffix}" ) ) {
			variation_message( "${prefix}_${article}_${suffix}", $string );
			return;
		}
	}
	$friendly_prefix = str_replace( 'finished/', '', $prefix );
	$friendly_prefix = str_replace( '_' , ' ', $friendly_prefix );
	$message = "missing test for <u>$friendly_prefix <i>$articles[0] $string</i></u>";
	if( $context->devmode ) {
		$prefix = str_replace( 'finished', 'current', $prefix );
		foreach( $articles as $article ) {
			if( file_exists( "scripts/${prefix}_${article}_${suffix}" ) ) {
				variation_message( "${prefix}_${article}_${suffix}", $string, 'bgcolor=#ffcc66' );
				return;
			}
		}
	}
	trouble($message);
}

function variation_message( $filename, $string, $color = '' ) {
	global $effective_label;
	$effective_label = "<a href=\"swim.php?file=$filename\"><font color=\"#cccccc\">variation</font></a>";
        echo "<p><table cellpadding=10 width=400 $color><tr><td>";
        echo $string;
        echo "</table></p>\n";
}

function advance( $delta ) {
	global $current;
	global $portal_objects;
	global $effective_time;
	global $effective_user;
	global $effective_label;
	global $context;

	/* delta must be null (report current time) or
	 * a valid SQL INTERVAL (see http://dev.mysql.com/doc/refman/5.0/en/date-and-time-functions.html)
	 */

  // no user login after advance
    $context->set("USER", null );
    $current = false;
    $portal_objects = array();
    $effective_user = 'nobody';

    $effective_label = ($delta == null) ? 'start' : "$delta later";

    $daythen = null;
	if( $delta ) {
	    $result = portal_sql("SELECT DATE(" . $context->now() . ") as now");
		$row = mysql_fetch_assoc( $result );
    	$daythen = $row['now'];
		if( strtolower($delta[strlen($delta)-1]) == "s") {
			$delta = substr($delta, 0, strlen($delta)-1);
		}
		$context->set( "NOW", "DATE_ADD(" . $context->now() . ",INTERVAL $delta)" );
	}
    $result = portal_sql("SELECT %NOW% as now, DAYNAME(%NOW%) as day");
	$row = mysql_fetch_assoc( $result );
    $now = $row['now'];
    $day = $row['day'];
    $effective_time = $now;
    if( $delta ) {
	    $result = portal_sql("SELECT DATE(" . $context->now() . ") as now");
		$row = mysql_fetch_assoc( $result );
    	$daynow = $row['now'];
    	if( $daynow != $daythen ) {
		    $cron = new DailyCron();
		    $cron->daily_activity( $context );
    		$cron->send_emails( $context );
    	}
    }
?>
<img align="absmiddle" src="images/clock.gif"> <?= $day ?> <?= $now ?><br>
<?php
	$context->max_affected_rows = 1;
}
function refresh() {
  global $context;
  login($context->get("USER"));
}

/*
 * Add a component to the list of relevent components for email tracking
 */
function ignore_email_from($component) {
	global $ignore_email_components;

	$ignore_email_components[$component] = 1;
}

/*
 * Find the active object of this type on the portal page
 */

function find( $class, $expr = "true") {
  global $current;
  global $portal_objects;
  $names=array(); foreach ($portal_objects as $each) $names[]=$each->id(); $names=join('<br>', $names);
  $x = 0;
  foreach ( $portal_objects as $y ) {
    try {
      $r = new ReflectionClass( $class );
    } catch( ReflectionException $x ) {
      trouble( "Component $class does not exist.  We have these:<p>$names" );
      return;
    }
    if( $y instanceof $class ) {
      $found = false;
      if( $expr == "true" ) {
        $found = true;
      } else {
        eval( "\$found = \$y->$expr;" );
      }
      if( $found ) {
		$x = $y;
        $current = $y;
		echo $current->outer_html();
 		report_test_label($current);
        break;
      }
    }
  }
  if( !is_object($x) ) {
    trouble ( "Cannot find component object of type $class with $expr. We have these:<p>$names" );
  }
  $_POST = array();
  $_REQUEST = array();
}

/*
 * Check that we can't Find the object of this type on the portal page
 */

function nofind( $class, $expr = "true") {
  global $portal_objects;
  foreach ( $portal_objects as $y ) {
    if( $y instanceof $class ) {
      $found = false;
      if( $expr == "true" ) {
        $found = true;
      } else {
        eval( "\$found = \$y->$expr;" );
      }
      if( $found ) {
        echo $y->outer_html();
        trouble ("didn't expect to find this object");
      }
    }
  }
}

function show() {
	// do nothing - this is an meta-comment to swim to show the current html
}
/*
 * perform an operation on the most recently found object
 */

function enter ( $key, $value ) {
  global $current_html;
  $_POST[$key]=$value;
  /*
   * Simulate the way the browser works so that the current_html
   * has all the fields filled in, etc.
   */
  $hvalue = htmlspecialchars($value);
  $count = 0;

  $result = preg_replace(
	"/(<input type=text name=$key size=\d+ value=\")[^\"]*?(\">)/",
	"<div class=\"highlightminus\"><div style=\"margin: 4px;\">\${1}$hvalue\${2}</span></span>",
	$current_html, 1, $count );
  if( $count ) {
  	$current_html = $result;
  	return;
  }

  $result = preg_replace(
	"/(<textarea name=$key rows=\d+ cols=\d+ wrap=virtual.*?>)[^<]*?(<\/textarea>)/",
	"<div class=\"highlightminus\"><div style=\"margin: 4px;\">\${1}$hvalue\${2}</span></span>",
	$current_html, 1, $count );
  if( $count ) {
  	$current_html = $result;
  	return;
  }

  $count = preg_match(
	"/<select[^>]+name=\"$key\">.*?<\/select>/s",
	$current_html, $matches );
  if( $count ) {
  	$text = $matches[0];
  	$retext = $matches[0];
  	$retext = preg_replace(
  		"/<option\s+selected\s+([^>]*)>/",
  		"<option $1>",
  		$retext );
  	$retext = preg_replace(
  		"/<option\s+(value=\"$value\">[^>]*<\/option>)/",
  		"<option selected $1",
  		$retext,
  		1 );
  	$current_html = str_replace( $text, "<div class=\"highlightminus\"><div style=\"margin: 4px;\">" . $retext . '</div></div>', $current_html );
  	return;
  }
}

function press ( $button, $param = null ) {
  global $current;
  global $current_html;
  global $context;
  check($button);
  $methods = get_class_methods ($current);
  if (!in_array ("{$button}_action", $methods)) {
    trouble( "Function {$button}_action does not exist in the current object." );
    return;
  }
  preg_match_all( "/<input type=hidden name=\"?([^ \"]+)\"?\s+value=\"?([^>\"]+)\"?.*>/", $current_html, $matches );
  foreach( $matches[1] as $idx => $m1 ) {
  		$m2 = $matches[2][$idx];
  		$_POST[$m1] = $m2;
  }
  ob_start();
  eval ("\$current->{$button}_action(\$context,'$param');");
  $html = ob_get_contents();
  ob_end_clean();
  index ($current, $button);
  $current->outer_html($html);
  report_test_label($current);
  $context->max_affected_rows = 1;
}

function choose ( $button, $retry = false) {
  global $current;
  global $current_html;
  $buttonpattern = preg_quote($button);
  $methods = get_class_methods ($current);
  $count = 0;
  /*
   * Simulate the way the browser works so that the current_html
   * has all the fields filled in, etc.
   */
  
  	if( preg_match( "/<input type=checkbox name=" . $buttonpattern . "[^>]*>/", $current_html )) {
		$result = preg_replace(
			"/(<input type=checkbox name=" . $button . " [^>]*)(>.*?)<\/td>/",
			"<div class=\"highlightminus\"><div style=\"margin: 4px;\">$1 checked$2</span></span></td>",
			$current_html, 1, $count );
		if( $count ) {
		  	$current_html = $result;
		}
  		$_POST[$button] = "on";
  		$_REQUEST[$button] = "on";
  		return;
  		}
  		
  if( preg_match( "/<input type=radio\s+name=([a-zA-Z0-9_]+)\s+[^>]*value=\"$buttonpattern\"[^>]*>/", $current_html, $matches )) {
  		$rname = $matches[1];
  		preg_replace(
  			"/(<input type=radio\s+name=$rname\s+[^>]*)checked([^>]*>)/",
  			"$1$2",
  			$current_html
  			);
		$result = preg_replace(
			"/(<input type=radio\s+name=$rname\s+[^>]*value=\"$buttonpattern\"[^>]*)(>.*?)<!-- -->/",
			"<span class=\"highlightminus\"><span style=\"margin: 4px;\">$1 checked $2</span></span>",
			$current_html, 1, $count );
		if( $count ) {
		  	$current_html = $result;
		}
  		$_POST[$rname] = $button;
  		$_REQUEST[$rname] = $button;
  		return;
  }

  if(!$retry && preg_match( "/<input type=(radio|checkbox)\s+name=([a-zA-Z0-9_]+)[^>]*$button/", $current_html, $matches )) {
    $name = $matches[2];
    choose($name, true);
    return;
  }

  trouble( "Radio button/checkbox {$button} does not exist in the current object." );
}

function check ( $needle, $ignore=false) {
  global $current_html;
  if ($ignore === false) {
    $haystack = $current_html;
  } else {
    $haystack = preg_replace ($ignore, '', $current_html);
  }
  if (strpos($haystack, $needle) === false) {
    trouble("can't find \"$needle\"");
  }
}

function omit ( $html ) {
  global $current_html;
  if (strpos($current_html, $html) !== false) {
    trouble("didn't expect to find \"$html\"");
  }
}

function check_sql($sql, $dbname, $needle_regex, $count = false) {
  $result = sql($sql, $dbname);
  $haystack = '';
  while($row = mysql_fetch_array($result)) {
  	$haystack .= implode(' ', $row);
  }
  if (preg_match($needle_regex, $haystack) == 0) {
    trouble("can't match \"$needle_regex\"");
  }
  if($count !== false) {
  	if(mysql_num_rows($result) != $count) {
  		trouble(mysql_num_rows($result) . " returned instead of $count expected");
  	}
  }
}

/*
 * Run the immediate email cron
 */
$sentemails = array();
function immediate_email_cron() {
  global $context;
  $cron = new SendImmediateEmails();
  $cron->send_emails( $context );
}

// helper
function store_email( $from, $to, $cc, $subject, $body, $source_file, $context ) {
  global $sentemails;
  global $current;
  global $ignore_email_components;

  $fields = explode('/', $source_file);
  $component = $fields[0];

  if(isset($ignore_email_components[$component])) {
	//trouble("component is: $component");
  	return;
  }
  index_email ($current, $source_file);
  $str = "From: $from\nTo: $to\n";
  if( isset($cc) && $cc != null ) $str .= "Cc: $cc\n";
  $str .= "Subject: $subject\n\n" . $body;
  $rec = array();
  $rec['text'] = $str;
  $rec['source'] = $source_file;
  $sentemails[] = $rec;
  //  echo $str;
}

/*
 * Verify that one or more emails were sent
 */
function email( $phrase, $who=null ) {
  immediate_email_cron();
  global $sentemails;
  global $effective_user;
  global $effective_label;
  global $effective_user_special_cases;
  if ($phrase == '*') {
    $effective_user='nobody';
    $count = count($sentemails);
    if ($count == 0)
	return;
    echo "<p><table width=400 bgcolor=#ffffdd cellpadding=15><tr><td><font color=gray>$count emails ignored<br><ul>\n";
    foreach ($sentemails as $msg) {
      $lines = preg_split ('/\n/', $msg['text']);
      echo "<li> ${lines[0]}\n";
    }
    echo "</ul></font></table></p>\n";
    $effective_label = "$count more<br>emails";
    $sentemails=array();
    return;
  }
  if( is_string( $who ) ) {
    $who = array( $who );
  }
  $effective_user = $who[0];
  if( isset($effective_user_special_cases[$effective_user]) )
  	$effective_user = $effective_user_special_cases[$effective_user];

  foreach( $who as $w ) {
    $found = false;
    $number = 0;
    foreach( $sentemails as $rec ) {
      $text = $rec['text'];
      $phrasepattern = preg_replace( "/ +/", '\s+', preg_quote($phrase, '/') );
      if( preg_match ("/$phrasepattern/", $text)
	  && !(strpos( $text, "To: $w" ) === false) ) {
	$found = true;
	$text = htmlentities( $text );
	$text = preg_replace( "/To: " . $w . "/", "To: <span style=\"background-color: #88FFCC\">" . $w . "</span>", $text );
	$text = preg_replace( "/(" . $phrasepattern . ")/", "<span style=\"background-color: #88FFCC\">$1</span>", $text );
?>
<p><table width=400 cellspacing=2 cellpadding=10 style="border: thin dashed">
<tr><td bgcolor=#FFFFDD><pre style="font-size: 90%"><?= $text ?>
</pre></td></tr>
</table>
<font size=-1 color=grey>&nbsp;&nbsp;&nbsp;&nbsp;from <?= $rec['source'] ?></font>
</p>
<?php
	preg_match('/([^\/]+)$/', $rec['source'], $result);
	$effective_label = str_replace('_','<br>',$result[1]);
	break;
      }
      $number = $number + 1;
    }
    if( !$found ) {
      trouble( "No email with phrase '$phrase' sent to '$w'");
    }
    array_splice($sentemails, $number, 1);
  }
}
/*
 * Verify that one or more emails were NOT sent
 */
function noemail( $phrase, $who=null ) {
  immediate_email_cron();
  global $sentemails;
  global $effective_user;
  global $effective_label;
  if( $who == null ) {
  	$who = "nobody";
  }
  if( is_string( $who ) ) {
    $who = array( $who );
  }
  $effective_user = $who[0];

  foreach( $who as $w ) {
    $found = false;
    $number = 0;
    foreach( $sentemails as $rec ) {
      $text = $rec['text'];
      $phrasepattern = preg_replace( "/ +/", '\s+', preg_quote($phrase, '/') );
      if( preg_match ("/$phrasepattern/", $text)
	  && !(strpos( $text, "To: $w" ) === false) ) {
	$found = true;
	$text = htmlentities( $text );
	$text = preg_replace( "/To: " . $w . "/", "To: <span style=\"background-color: #FF88CC\">" . $w . "</span>", $text );
	$phrasepattern = preg_replace( "/ +/", '\s+', preg_quote($phrase, '/') );
	$text = preg_replace( "/(" . $phrasepattern . ")/", "<span style=\"background-color: #FF88CC\">$1</span>", $text );
?>
<p><table width=400 cellspacing=2 cellpadding=10 style="border: thin dashed">
<tr><td bgcolor=#FFFFDD><pre style="font-size: 90%"><?= $text ?>
</pre></td></tr>
</table>
<font size=-1 color=grey>&nbsp;&nbsp;&nbsp;&nbsp;from <?= $rec['source'] ?></font>
</p>
<?php
	preg_match('/([^\/]+)$/', $rec['source'], $result);
	$effective_label = str_replace('_','<br>',$result[1]);
	break;
      }
      $number = $number + 1;
    }
    if( $found ) {
      trouble( "Email with phrase '$phrase' incorrectly sent to '$w'");
    }
    array_splice($sentemails, $number, 1);
  }
}

/*
 * Note that a user has multiple email addresses
 */
function additionalemail( $additional_email_address, $who = null ) {
  global $effective_user;
  global $effective_user_special_cases;
  if( $who == null )
  	$who = $effective_user;
  $effective_user_special_cases[$additional_email_address] = $who;
}

/*
 * Check for expected completion of script. Tests include:
 *   - no unaccounted for email generated
 */

function complete () {
  immediate_email_cron();
  global $sentemails;
  foreach ($sentemails as $email) {
    $text = $email['text'];
	$text = htmlentities( $text );
  	ob_start();
?>
<p><table width=400 cellspacing=2 cellpadding=10 style="border: thin dashed">
<tr><td><pre style="font-size: 90%"><?= $text ?>
</pre></td></tr>
</table>
<font size=-1 color=grey>&nbsp;&nbsp;&nbsp;&nbsp;from <?= $email['source'] ?></font>
</p>
<?php
	$output = ob_get_contents();
	ob_end_clean();
    trouble ("unexpected email remains at test completion: $output");
  }
}

/*
 * Check for trace buffer output.
 */

function trace_buffer_flush () {
  global $context;
  if ( $context->trace_buffer != '') {
    echo "<font color=brown>{$context->trace_buffer}</font>\n";
    $context->trace_buffer = '';
  }
}

function report_test_label($object) {
  ?><div style="margin: -10px 0px 10px 12px;"><font size=-1 color=grey>&nbsp;&nbsp;&nbsp;&nbsp;from <?= $object->test_label() ?></font></div><?php
}
?>