<?php
require_once( "../classes/external_entry_point.php");
external_entry( false );
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/


$db = isset($_REQUEST['db']) ? $_REQUEST['db'] : 'myfoundation';


?>

<html>
<title>DB Explorer (<?= $db ?>)</title>
<head>
<style>
a {
	color: #20b020;
	font-weight: bold;
	text-decoration: none;
}
div.code {
	color: #20b020;
}
</style>
</head>

<body>

<?php

$demo_list = '';
$test_list = '';
foreach($context->databases as $key=>$value) {
	$dbname = $value['DATABASE'];
	if (preg_match('/_test$/', $key)) {
		$test_list .= "<tr><td align=right><a href=\"?db=$key\">$key</a></td><td>$dbname";
	} else {
		$demo_list .= "<tr><td align=right><a href=\"?db=$key\">$key</a></td><td>$dbname";
	}
}
$demo_list = substr($demo_list, 4);
$test_list = substr($test_list, 4);
echo "<font color=gray>Databases</font><table cellpadding=15 cellspacing=10><tr bgcolor=#eeeeee><td><table>$demo_list</table><td><table>$test_list</table></table>";


$dbh = $context->database( $db ); 

// Show all the table names
$result = mysql_remember_query( "SHOW tables", $dbh );
echo mysql_error();

if(isset($_REQUEST['table'])) {
	show_table( $_REQUEST['table'] );
	show_insert( $_REQUEST['table'] );	
} else {
	$tables = array();
	echo "<font color=gray>Tables</font><table cellpadding=15 cellspacing=10><tr bgcolor=#eeeeee><td><table>";

	while(($row = mysql_fetch_assoc( $result )) !== false) {	
		foreach($row as $key) {
			$tables[] = $key;
			echo "<tr><td align=right><a href=\"#$key\">$key</a><td><a href=\"?db=$db&table=$key&limit=100\">code</a>";
		}
	}
	echo "</table></table>";
	foreach ($tables as $key) {
		show_table($key);
	}
}

function show_table( $name ) {

	global $dbh;
	global $db;
	
	echo "<a name=\"$name\"></a><font color=\"#BBBBBB\"><h1>$name</h1></font>";
	echo "<table cellpadding=\"3\">";
	
	// List the columns from this table
	$columns = array();
	echo "<tr>";
	$result = mysql_remember_query( "SHOW COLUMNS FROM $name", $dbh );
	while(($row = mysql_fetch_assoc( $result )) !== false) {
		echo "<td align=\"center\"><font color=\"gray\" size=\"-1\">", $row['Type'], "</font></td>";
	}
	echo "</tr>";

	$result = mysql_remember_query( "SHOW COLUMNS FROM $name", $dbh );
	echo "<tr>";
	while(($row = mysql_fetch_assoc( $result )) !== false) {
		echo "<th>", $row['Field'], "</th>";
		$columns[] = $row['Field'];
	}
	echo "</tr>";
	
	// Display all the rows
	$limit = isset($_REQUEST['limit']) ? $_REQUEST['limit'] : 100;
	$result = mysql_remember_query( "SELECT * FROM $name LIMIT $limit", $dbh );
	$rowcount = 0;
	while(($row = mysql_fetch_assoc( $result )) !== false) {

		$color = ($rowcount++) % 2 ? "#88FF88" : "#BBFFBB";	
		echo "<tr bgcolor=\"$color\">";
		foreach($columns as $key) {
			$data = $row[$key];
			$data = htmlspecialchars($data);
			$data = strlen($data) > 25 ? (substr($data,0,25) . "...") : $data;
			echo "<td>$data</td>";
		}
		echo "</tr>";
	}
	echo "</table>";
	if ($rowcount >= $limit) {
		$bigger = $limit * 10;
		echo "<br>row limit of $limit reached. <a href=\"?db=$db&table=$name&limit=$bigger\"> show more ...</a>";
	} else {
		echo "<br><font color=gray>$rowcount rows</font>";
	}
}

function show_insert( $name ) {

	global $dbh;
	global $db;
	
	$values = array();
	$fields = array();

	$limit = isset($_REQUEST['limit']) ? $_REQUEST['limit'] : 100;
	// SELECT * FROM foo WHERE id IN (xxx, xxx, xxx)
	$result = mysql_remember_query( "SELECT * FROM $name LIMIT $limit", $dbh );
	
	echo "<div class=\"code\"><pre>";
	echo $db . "_sql(\"INSERT INTO ${name}\$suffix (";
	$row = mysql_fetch_assoc($result);
	foreach($row as $key=>$value) {
		$fields[] = $key;
		$values[] = is_numeric($value) ? $value : "'" . $value ."'";
	}
	echo implode(',', $fields);
	echo ") VALUES\n(";
	echo implode(',', $values);
	echo ")";
	while($row = mysql_fetch_array( $result )) {
		echo ",\n(";
		$values = array();
		foreach($fields as $key) {
			$value = $row[$key];
			$values[] = is_numeric($value) ? $value : "'" . $value ."'";
		}
		echo implode(',', $values);
		echo ")";
	}
	echo "\");\n</pre><br><br></div>";
}
?>


</body>
</html>
