<?php
require_once( "../classes/external_entry_point.php");
external_entry( false );
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
?>
<h1>Portal Source</h1>

<p><font color=gray>All code copyright &copy; 2006, Eclipse Foundation, Released under EPL 1.0</font></p>
<?php

require_once ($GLOBALS['CLASSES_DIRECTORY'] . "functions.php");

$vers=$_GET['vers'];
$grep=$_GET['grep'];
$total_lines = 0;

function functs_in_file ($path) {
  global $total_lines, $grep;
  $lines = file($path);
  foreach ($lines as $line) {
    $total_lines++;
    if (preg_match('/^\s*(public)?\s*function +(\w+)/', $line, $matches)) {
      echo "<li>function {$matches[2]}\n";
    }
    if (preg_match('/^\s*(abstract)?\s*(class|interface) +(\w+)/', $line, $matches)) {
      echo "<p/><li>{$matches[2]} {$matches[3]}\n";
    }
    if (preg_match('/mysql_remember_query\s*\(\s*\"?(\w+)?/', $line, $matches)) {
      echo "<li>sql {$matches[1]}\n";
    }
    if (preg_match('/TO[D]O(.*)/', $line, $matches)) {
      echo "<li><font color=brown>todo{$matches[1]}</font>\n";
    }
    if (preg_match('/trace *\( *\"(\w+)/', $line, $matches)) {
      echo "<li><font color=brown>trace {$matches[1]}</font>\n";
    }
    if ($grep != '' && preg_match("/\b$grep\b/", $line, $matches)) {
      echo "<li><font color=#bbbb00>", htmlspecialchars( $line ), "</font>";
    }
  }
}

function files_in_dir ($path) {
  global $vers;
  echo "<h2>$path</h2>";
  foreach (files($path) as $file) {
    if (strstr($file, '.php') == '.php') {
      echo "<h3><a href=dev-see.php?file=$path/$file&vers=$vers>$file</a></h3>\n";
      functs_in_file ("$path/$file");
    }
  }
}

function dirs_in_dir ($path) {
  echo "<h2>$path</h2>\n";
  foreach (dirs($path) as $name) {
    files_in_dir ("$path/$name");
  }
}

function dirs_in_history ($path) {
  echo "<h2>history</h2>\n";
  foreach (dirs($path) as $name) {
    echo "<li><a href=?vers=$name>$name</a>\n";
  }
}

function tally_lines() {
  global $total_lines;
  echo "<p><font color=gray>$total_lines source lines above</font></p>\n";
  $total_lines = 0;
}

chdir('..');
if ($vers) { 
  echo "Version as of $vers";
  chdir("../oldfoundation/$vers"); 
}
?>

<table cellpadding=5>
  <tr>
    <td valign=top> 
      <? files_in_dir ('portal');
         files_in_dir ('tests');
         files_in_dir ('releng');
         tally_lines ();
         // dirs_in_history ('/home/bfreeman/oldfoundation'); ?>
    <td valign=top>
      <? dirs_in_dir ('components');
         tally_lines (); ?>
    <td valign=top>
      <? files_in_dir ('classes');
         tally_lines (); ?>
</table>

