<?php 
require_once( "../classes/external_entry_point.php");
external_entry( false, "Use Case Breakdown" ); 
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/

legend("Buttons", "This table shows the number of actions performed by the finished and successful
<a href=index.php>portal use cases</a> broken down by component and action.");
breakdown ("explore");

legend("Emails", "This table shows the number of emails sent by the finished and successful
<a href=index.php>portal use cases</a> broken down by component and email name.");
breakdown ("email");

function breakdown ($sufix) {
global $context;

$compclas = array();
$act = array();
$compclasact = array();

$files = files( $context->get('indices_directory'));
foreach( $files as $filename ) {
	if( !preg_match( "/\.$sufix$/", $filename )) continue;
	$lines = file( $context->get('indices_directory') . $filename );
	foreach( $lines as $line ) {
		if( $line == 'end-of-input') break;
		list( $file, $line, $comp, $clas, $actkey ) = explode( "\t", $line );
		if( isset($compclas["$comp-$clas"]) ) $compclas["$comp-$clas"]++; else $compclas["$comp-$clas"] = 1;
		if( isset($act[$actkey]) ) $act[$actkey]++; else $act[$actkey] = 1;
		if( isset($compclasact["$comp-$clas-$actkey"]) ) $compclasact["$comp-$clas-$actkey"]++; else $compclasact["$comp-$clas-$actkey"] = 1;
	}
}

$actkeys = array_keys( $act );
sort( $actkeys );
$compclaskeys = array_keys( $compclas );
sort( $compclaskeys );

?><table cellpadding=4><tr><th><?php
if( count($actkeys) != 0 ) {
	foreach( $actkeys as $actkey ) {
		$file = preg_replace ('/_/', '<br>', $actkey); 
		?><th valign=bottom><?= $file ?></th><?php
	}
}
foreach( $compclaskeys as $compclaskey ) {
	list($comp, $clas) = explode( '-', $compclaskey );
	$label = ($comp == $clas) ? $comp : "$comp<br><font color=gray>$clas</font>";
	?><tr><th align=right><?= $label ?></th><?php
	if( count($actkeys) != 0 ) {
		foreach( $actkeys as $actkey ) {
			$count = $compclasact["$compclaskey-$actkey"];
			?><td align=center bgcolor=#bbffbb>
			  <a href=explore.php?component=<?= $comp ?>&class=<?= $clas ?>&action=<?= $actkey?>><?= $count ?></a>
			<?php
		}
	}
}
?>
</table><br><br>
<?
}


function legend ($headline, $text) {
?>
<table width=400><tr><td><font color=gray>
<h3><?= $headline ?></h3>
<?= $text ?>
</table>
<?
}
?>
