<?php
require_once( "../classes/external_entry_point.php");
external_entry( false );
/*******************************************************************************
 * Copyright (c) 2006-2007 Eclipse Foundation
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Bjorn Freeman-Benson - initial API and implementation
 *    Ward Cunningham - initial API and implementation
 *    Karl Mathias - initial API and implementation
 *******************************************************************************/
require_once( "../classes/test-context.php");
require_once( "test-functions.php" );

if ($_GET['file']) {
  $file = $_GET['file'];
  $path = "scripts/$file";
} elseif ($argv[1]) {
  $file = $path = $argv[1];
}
$emphasizing = split(',', $_GET['lines']);
$show_sql = $_GET['sql']
?>
<html>
<head>
<link rel="stylesheet" type="text/css" href="../portal/images/portal.css">
<link rel="stylesheet" type="text/css" href="images/swim.css">
<script language="JavaScript" type="text/javascript" src="images/swim.js">
</script>
<script src="../portal/AjaxRequest.js">
</script>
<style>
a.swamlink {
	color: gray;
	text-decoration: none;
	font-size: small;
}
</style>
</head>
<body>

<h1 id="headerline">&nbsp;<?= test_title($file) ?></h1>

<?php


function trouble( $string ) {
	global $effective_label;
	$effective_label = "trouble";
        echo "<p><table cellpadding=10 width=400 bgcolor=#ffcccc><tr><td><font size=+2>Trouble: </font>";
        echo $string;
        echo "</table></p><script language=\"JavaScript\" type=\"text/javascript\">troubleseen = 1;</script>\n";
}
function index ($component, $action) {
}

function index_email ($component, $action) {
}


function shortline ($line, $current_html) {
        $shortline = $line;
        if( substr($line,0,6) == "press(") {
                preg_match( "/press\(\s*[\"\']([^\'\"]*)[\'\"]\s*(,\s*[\"\']([^\'\"]*)[\'\"]\s*)?\)/", $line, $matches);
                if( strpos($current_html, 'value="' . $matches[1] . '"') > 0 ) {
                        $shortline = "<input type=submit name=nothing value=" .$matches[1] . ">";
                } else {
                        $shortline = "<a href=\"#\">" .$matches[1] . "</a>";
                }
        } else {
                if( strlen($shortline) > 8 ) $shortline = substr($shortline,0,8) . "...";
                $shortline = htmlspecialchars($shortline);
        }
	return $shortline;
}
function highlight ($line, $current_html) {
        $result = $current_html;
        if( substr($line,0,6) == "press(") {
                preg_match( "/press *\(.*[\"\']([^\'\"]*)[\'\"]\s*\)/", $line, $matches);
                $key = $matches[1];
                $pkey = preg_quote($key);
                if( strpos($current_html, "value=\"$key\"") > 0 ) {
                	$result = preg_replace( "/(\<input [^\>]*value=\"$pkey\"[^\>]*\>)/",
							"<span class=\"highlight\"><span style=\"margin: 4px;\">$1</span></span>",
							$current_html );
                } else {
                	$result = preg_replace( "/(\<a href=\"[^\"]+action=$pkey\"\>.*?\<\/a\>)/s",
                			"<span class=\"highlight\"><span style=\"margin: 4px;\">$1</span></span>", $current_html );
                }
         }
		return $result;
}

function width ($html) {
        $width = 480;
        if( substr($html,0,19) == '<p><table width=400') $width = 600;
	return $width;
}

function color ($html) {
        $color='#ffffff';
        if ( preg_match ( "/bgcolor=\"?(#[a-zA-Z0-9]+)/", $html, $matches)) {
                $color = $matches[1];
        }
	return $color;
}


function bubble ($number, $html, $shortline, $width, $color) {
  global $emphasizing;
  $emphasize = in_array($number, $emphasizing);
  if ($emphasize) echo "<div class=\"highlight\" ><div style=\"margin: 2px;\">";
?>
<div class="hint" style="background-color: <?= $color ?>;" onmouseover="over(this,'tip<?= $number ?>')" onmouseout="out('tip<?= $number ?>')"><?= $shortline ?></div>
<?php
  if ($emphasize) echo "</div></div>";
?>
<div class="tip" id="tip<?= $number ?>">
<TABLE WIDTH=<?= $width ?> BORDER=0 CELLPADDING=0 CELLSPACING=0>
<TR><TD class="balloon1"></TD><TD class="balloon2"></TD><TD class="balloon3"></TD></TR><TR><TD class="balloon4"></TD>
<TD class="balloon5" id="tip<?= $number ?>inner"><?= $html ?></TD>
<TD class="balloon6"></TD></TR><TR><TD class="balloon7"></td><TD class="balloon8"></td><TD class="balloon9"></td></tr></TABLE>
</div>
<?php
}
$total_sql_count = 0;
function sql_swim_backtrace () {
	global $query_btrace;
	global $total_sql_count;

	$row = 1;
	echo "<p><table cellpadding=10 width=550 bgcolor=#ccddee><tr><td>";
	echo "<div style=\"font-family: courier;font-size: small;\">";
	foreach ($query_btrace as $query) {
		$q = $query{1};
		$q = preg_replace('/(\b[A-Z]{2,}\b)/', "<b>$1</b>", $q);
		echo "<br><font color=#8899aa>" .
			$query{0} ." (" . $query{2} . ")rows:</font><div style='margin-left: 2em'> " . $q . "</div>\n";
		$row++;
		$total_sql_count++;
	}
	echo "</div>";
	echo "</p>\n";
	echo "</table></p>\n ";

}

function perform_line($number, $line) {
  global $context;
  global $file;
  global $portal_objects;
  global $current_html;
  global $effective_user;
  global $effective_time;
  global $effective_label;
  global $users, $lanes;
  global $query_btrace;
  global $show_sql;

  ob_start();
  if($context->devmode) {
  ?>
    <a class="swamlink" href="dev-swam.php?file=<?= $file ?>&break=<?= $number?>"><?= $number ?></a>
  <?php
  } else {
  ?>
    <font color=gray size=-1><?= $number?></font>
  <?php
  }

  $effective_user = $context->user();
  $effective_label = '';
  ob_start();
  $result = eval($line);
  $html=ob_get_contents();
  ob_end_clean();
  $html = sanitize_images_in_html( $html );
  if(strlen(trim($html)) == 0) { $html = ''; }

  $verb = '';
  if (preg_match('/\s*(\w+)/', $line, $result)) {
    $verb = $result[1];
  }
  if ($verb == 'find') {
    // ignore
  } elseif ( $verb == 'press') {
    bubble ($number, highlight($line,$current_html), shortline($line, $current_html), width($current_html), color($current_html));
  } elseif( $html ) {
    $effective_label = ($effective_label != '') ? $effective_label : shortline($line, $current_html);
    bubble ($number, $html, $effective_label, width($html), color($html));
  } elseif( $verb == 'show') {
  	$effective_label = '<font color=gray>(result)</font>';
    bubble ($number, $current_html, $effective_label, width($current_html), color($current_html));
  }

  if ($show_sql && $context->devmode && sizeof($query_btrace) > 0){
  	ob_start();
  	sql_swim_backtrace();
  	$sql_html = ob_get_contents();
  	ob_end_clean();
  	$count = count($query_btrace);
  	bubble ("x$number", "$line<br>$sql_html", "$count queries", 600, "#ccddee");
  	$query_btrace = array();
  }


  if( $result === false ) {
    trouble("Can't parse test statement. Check for unescaped punctuation, e.g., ' \", mismatched parentheses, etc. $html");
  }

  if ($html) $current_html = $html;
  trace_buffer_flush();
  $contents = ob_get_contents();
  ob_end_clean();
  if (!isset($lanes[$effective_time])) $lanes[$effective_time] = array();
  if (!isset($lanes[$effective_time][$effective_user])) $lanes[$effective_time][$effective_user] = '';
  $lanes[$effective_time][$effective_user] .= $contents;
  $users[$effective_user]=1;

}

$current_html = '';
$lanes = array();
$users = array();
$context->set("USER", 'nobody');
$effective_user = 'nobody';
$users['nobody']=1;
$effective_time = 'notime';
require_once( "../classes/harness.php" );
echo "<p/>";

$lines = file($path);
$number = 0;
perform_line ($number, "advance( null );");

foreach ($lines as $line) {
  $number++;
  perform_line($number, $line);
}

$boundary = "<td>&nbsp;&nbsp;<td bgcolor=#cccccc>&nbsp;<td>&nbsp;&nbsp</td>\n";
echo "<table cellspacing=0 cellpadding=1><tr>";
foreach ($users as $ukey => $uvalue) {
  $key = ($ukey=='nobody') ? '' : $ukey;
  echo "<th>$key$boundary";
}
echo "<td>" . str_repeat('&nbsp;', 120); // pad table with extra blank column
foreach ($lanes as $tkey => $tvalue) {
  echo "<tr>";
  foreach ($users as $ukey => $uvalue) {
    echo "<td valign=top>\n";
    if (isset($lanes[$tkey][$ukey]))
      echo $lanes[$tkey][$ukey];
    else
      echo "&nbsp;";
    echo $boundary;
  }
  echo "<tr>";
  foreach ($users as $ukey => $uvalue) {
    echo "<td valign=top>&nbsp;$boundary";
  }

}
echo "</table>";
complete();
?>
<script language="JavaScript" type="text/javascript">
if( troubleseen ) {
	reportfatalerror();
} else {
	reportsuccess();
}
</script>

<table width=400><tr><td>
<font color=gray>
<p>This diagram shows one hypothetical use of the MyFoundation portal.
Each lane shows the use from the perspective of a different user or group.
Roll over small squares to show what those users see on their portal screen.
The left lane shows system activity including substantial elapsed time.
Within each period, the actual sequence of events is noted by small numbers.
</p><p>
You can <a href=see.php?file=<?= $file ?>>see</a> the script for this case
or <a href=run.php?file=<?= $file ?>>run</a> it as it has been run during development.
</p>
<?php
if ($context->devmode && !$show_sql) {
	?>
	Developers can see the <a href=swim.php?<?= $_SERVER['QUERY_STRING']?>&sql=on>sql</a> generated by each statement.
	<?php
}
?>

</table>

</body>
</html>
